var aContacts = new Array()
var aControls = new Array(6);
var aSelectLines = new Array(6);
var oTabs = new Array(6);
var aAlphabet = new Array(36);
var aContactsDisplayList = new Array();
var imgError;
var iAlphaIndex = 0;
var iTabIndex = 0;
var iLineIndex = 0;
var iPageControl = 1;
var iMaxPages = 1;
var iMaxPageItems = 6;
var iContactId;
var timerError;
var strErrMsg
var iSeconds;
var iCountdown;
var timerScroll;
var timerDelay = 150;
var strScroll;


// load contacts from XML file
function loadContacts()
{

	try
	{
		var xmlDoc;
		xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
		xmlDoc.async=false;
		xmlDoc.load("PhonebookContacts.xml");

		var x=xmlDoc.getElementsByTagName("CONTACT");
		var item;

		iContactId = 0;
		for (var i=0;i<x.length;i++)
		{
			if ( getXMLData(x[i], "NAME").length > 0 ) 
			{
				aContacts.push(["" , "", "", "", "", "", "" , "" , "" , "" , "" , "" , "" , "" , "" , "" , 0, iContactId++]);
				aContacts[iContactId-1][0]  = getXMLData(x[i], "NAME");
				aContacts[iContactId-1][1]  = getXMLData(x[i], "PHONE_1");
				aContacts[iContactId-1][2]  = getXMLData(x[i], "PHONE_2");
				aContacts[iContactId-1][3]  = getXMLData(x[i], "PHONE_3");
				aContacts[iContactId-1][4]  = getXMLData(x[i], "PHONE_4");
				aContacts[iContactId-1][5]  = getXMLData(x[i], "MOBILE_1");
				aContacts[iContactId-1][6]  = getXMLData(x[i], "MOBILE_2");
				aContacts[iContactId-1][7]  = getXMLData(x[i], "MOBILE_3");
				aContacts[iContactId-1][8]  = getXMLData(x[i], "MOBILE_4");
				aContacts[iContactId-1][9]  = getXMLData(x[i], "WORK_1");
				aContacts[iContactId-1][10] = getXMLData(x[i], "WORK_2");
				aContacts[iContactId-1][11] = getXMLData(x[i], "EMAIL_1");
				aContacts[iContactId-1][12] = getXMLData(x[i], "EMAIL_2");
				aContacts[iContactId-1][13] = getXMLData(x[i], "SKYPE_1");
				aContacts[iContactId-1][14] = getXMLData(x[i], "ICQ_1");
				aContacts[iContactId-1][15] = getXMLData(x[i], "COMMENTS_1");
			}
	 	}

		// sort contacts by name
		aContacts.sort(charOrdA);

		xmlDoc = undefined;
		x = undefined;
	}
	catch(err)
	{
		strErrMsg =  ':' + err.number;
  		strErrMsg += '\n:' + err.description;
		strErrMsg += "\n\n,     !";
		strErrMsg += "      .";
		iCountdown = 0;
		iSeconds = 0;
		showError();
	}

}


function writeContactsXML() 
{

	try 
	{
   		var fso, s, f;
   		fso = new ActiveXObject("Scripting.FileSystemObject");

		// *** CHECK FILE READONLY ATTRIBUTE ***
	  	f = fso.GetFile( System.Gadget.path + "\\PhonebookContacts.xml");
		if (f.attributes & 1)
			f.attributes = f.attributes - 1;

   		s = fso.OpenTextFile( System.Gadget.path + "\\PhonebookContacts.xml", 2, true, 0);

		s.writeline('<?xml version="1.0" encoding="windows-1251"?>');
		s.writeline('<CONTACTS>');
			for (var i = 0; i < aContacts.length; i++)
			{

				try 
				{
					s.writeline('	<CONTACT>');
						s.writeline('		<NAME>'       + aContacts[i][0]  + '</NAME>');
						s.writeline('		<PHONE_1>'    + aContacts[i][1]  + '</PHONE_1>');
						s.writeline('		<PHONE_2>'    + aContacts[i][2]  + '</PHONE_2>');
						s.writeline('		<PHONE_3>'    + aContacts[i][3]  + '</PHONE_3>');
						s.writeline('		<PHONE_4>'    + aContacts[i][4]  + '</PHONE_4>');
						s.writeline('		<MOBILE_1>'   + aContacts[i][5]  + '</MOBILE_1>');
						s.writeline('		<MOBILE_2>'   + aContacts[i][6]  + '</MOBILE_2>');
						s.writeline('		<MOBILE_3>'   + aContacts[i][7]  + '</MOBILE_3>');
						s.writeline('		<MOBILE_4>'   + aContacts[i][8]  + '</MOBILE_4>');
						s.writeline('		<WORK_1>'     + aContacts[i][9]  + '</WORK_1>');
						s.writeline('		<WORK_2>'     + aContacts[i][10] + '</WORK_2>');
						s.writeline('		<EMAIL_1>'    + aContacts[i][11] + '</EMAIL_1>');
						s.writeline('		<EMAIL_2>'    + aContacts[i][12] + '</EMAIL_2>');
						s.writeline('		<SKYPE_1>'    + aContacts[i][13] + '</SKYPE_1>');
						s.writeline('		<ICQ_1>'      + aContacts[i][14] + '</ICQ_1>');
						s.writeline('		<COMMENTS_1>' + aContacts[i][15] + '</COMMENTS_1>');
					s.writeline('	</CONTACT>');
				}
				catch(err)
				{
					strErrMsg =  ':' + err.number;
			  		strErrMsg += '\n:' + err.description;
					iCountdown = 10;
					iSeconds = 0;
					showError();
					break;
				}
			}
		s.writeline('</CONTACTS>');
   		s.Close();
 	}
	catch(err)
	{
  		strErrMsg = 'writeContactsXML:';
		strErrMsg += '\n:' + err.number;
  		strErrMsg += '\n:' + err.description;
		iCountdown = 10;
		iSeconds = 0;
		showError();
	}

}


// loads alphabet into an array
function loadAlphabet()
{

	aAlphabet[0] = '#';
	aAlphabet[1] = '';
	aAlphabet[2] = '';
	aAlphabet[3] = '';
	aAlphabet[4] = '';
	aAlphabet[5] = 'q';

	aAlphabet[6]  = 'p';
	aAlphabet[7]  = '';
	aAlphabet[8]  = '';
	aAlphabet[9]  = '';
	aAlphabet[10] = '';
	aAlphabet[11] = 'q';

	aAlphabet[12] = 'p';
	aAlphabet[13] = '';
	aAlphabet[14] = '';
	aAlphabet[15] = '';
	aAlphabet[16] = '';
	aAlphabet[17] = 'q';

	aAlphabet[18] = 'p';
	aAlphabet[19] = '';
	aAlphabet[20] = '';
	aAlphabet[21] = '';
	aAlphabet[22] = '';
	aAlphabet[23] = 'q';

	aAlphabet[24] = 'p';
	aAlphabet[25] = '';
	aAlphabet[26] = '';
	aAlphabet[27] = '';
	aAlphabet[28] = '';
	aAlphabet[29] = 'q';

	aAlphabet[30] = 'p';
	aAlphabet[31] = '';
	aAlphabet[32] = '';
	aAlphabet[33] = '';
	aAlphabet[34] = '';
	aAlphabet[35] = 'q';

	aAlphabet[36] = 'p';
	aAlphabet[37] = '';
	aAlphabet[38] = '';
	aAlphabet[39] = '';
	aAlphabet[40] = '';
	aAlphabet[41] = '';

}

function locateUpdatedContact( strAlpha, id)
{
	try
	{

		var i;
		var i2;
		var first = 0;
		var strChar = "";
		var strCode = 0;
		var strComp = "";

		// Locate the correct TAB for updated contact
		for ( i = 0; i < 7; i++)
		{
			for ( i2 = 0; i2 < 6; i2++)
			{
				if (aAlphabet[(i*6)+i2] == strAlpha.charAt(0).toUpperCase())
				{
					iTabIndex = i2;
					iAlphaIndex = (i*6);
				}
			}
		}

		// sort contacts by name
		aContacts.sort(charOrdA);
		
		// Locate the correct page for updated contact
		iPageControl = 1;
		if (id >= 0 )
		{
			for (i = 0; i < aContacts.length; i++)
			{
	
				strCode = aContacts[i][0].toUpperCase().charCodeAt(0);
				if (strCode < 65 || strCode > 90)
					strComp = "#";
				else
					strComp = aContacts[i][0].toUpperCase().charAt(0);

				if (strComp != strChar)
				{
					//strDebug.innerText = strChar + ' ' + strComp;
					first = i;
					strChar = strComp;
					 
				}

				if (aContacts[i][7] == id)
				{
		
					//strDebug.innerText = iPageControl + ' ' + id + ' ' + i + ' ' + first;
			
					if ((i-first+1) > (iMaxPageItems))
						iPageControl = Math.ceil( (i-first+1) / (iMaxPageItems));
	
					break;
	
				}
		
			}
		}


	}
	catch(err)
	{
		strErrMsg = 'locateUpdatedContact:';
		strErrMsg += '\n:' + err.number;
  		strErrMsg += '\n:' + err.description;
		iCountdown = 10;
		iSeconds = 0;
		showError();
	}

}

// show page controls and add contact button
function showControls()
{

	// phonebook page control image
	imgBackground.addImageObject('images/pagecontrol.png', 30, 135);

	// phonebook control buttons
	aControls[0] = imgBackground.addImageObject('images/bPlus.png'     , 101, 4);
	aControls[1] = imgBackground.addImageObject('images/bPlus-over.png', 101, 4);
	aControls[2] = imgBackground.addImageObject('images/bPrev.png'     ,  33, 137);
	aControls[3] = imgBackground.addImageObject('images/bPrev-over.png',  33, 137);
	aControls[4] = imgBackground.addImageObject('images/bNext.png'     ,  87, 137);
	aControls[5] = imgBackground.addImageObject('images/bNext-over.png',  87, 137);

	// controls buttons select effect 
	aControls[1].opacity = 0;
	aControls[3].opacity = 0;
	aControls[5].opacity = 0;

	// create ADD control
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 101;
	m.style.posTop = 4;
	m.style.posHeight = 16;
	m.style.posWidth = 16;
	m.onmouseover = showAdd;
	m.onmouseout  = hideAdd;
	m.onclick = clickAdd;
	targets.appendChild(m);

	// create PREV controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 33;
	m.style.posTop = 137;
	m.style.posHeight = 16;
	m.style.posWidth = 16;
	m.onmouseover = showPrev;
	m.onmouseout  = hidePrev;
	m.onclick = clickPrev;
	targets.appendChild(m);

	// create NEXT controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 87;
	m.style.posTop = 137;
	m.style.posHeight = 16;
	m.style.posWidth = 16;
	m.onmouseover = showNext;
	m.onmouseout  = hideNext;
	m.onclick = clickNext;
	targets.appendChild(m);

}

// control selected effect
function showAdd()  { if (!System.Gadget.Flyout.show) { aControls[1].opacity = 100; aControls[0].opacity = 0;} }
function showPrev() { if (!System.Gadget.Flyout.show) { aControls[3].opacity = 100; aControls[2].opacity = 0;} }
function showNext() { if (!System.Gadget.Flyout.show) { aControls[5].opacity = 100; aControls[4].opacity = 0;} }

function hideAdd()  { aControls[0].opacity = 100; aControls[1].opacity = 0;}
function hidePrev() { aControls[2].opacity = 100; aControls[3].opacity = 0;}
function hideNext() { aControls[4].opacity = 100; aControls[5].opacity = 0;}

// Previous page control function
function clickPrev() 
{ 
	if (iPageControl > 1 && !System.Gadget.Flyout.show) 
	{ 
		iPageControl--; 
		eval("showContacts('"+aAlphabet[iAlphaIndex + iTabIndex]+"');"); 
	} 
}

// Next page control function
function clickNext() 
{ 
	if (iPageControl < iMaxPages && !System.Gadget.Flyout.show) 
	{ 
		iPageControl++; 
		eval("showContacts('"+aAlphabet[iAlphaIndex + iTabIndex]+"');"); 
	} 
}
	

// control PLUS acction
function clickAdd() 
{ 

	if (!System.Gadget.Flyout.show)
	{	
		// initialize flyout return action
		//flyoutAction.value = "addContact";
		System.Gadget.Settings.write("flyoutAction", "addContact");

		// clean-up variables to send the contacts info to Flyout page
		strContactName.value   	   = "";
		strContactPhone_1.value    = "";
		strContactPhone_2.value    = "";
		strContactPhone_3.value    = "";
		strContactPhone_4.value    = "";
		strContactMobile_1.value   = "";
		strContactMobile_2.value   = "";
		strContactMobile_3.value   = "";
		strContactMobile_4.value   = "";
		strContactWork_1.value     = "";
		strContactWork_2.value     = "";
		strContactEmail_1.value    = "";
		strContactEmail_2.value    = "";
		strContactSkype_1.value    = "";
		strContactIcq_1.value  	   = "";
		strContactComments_1.value = "";

		// show flyout page
		System.Gadget.Flyout.show = true;
	}

}

// show text lines separatos and mouse select effect
function showTextLines()
{

	// contacts lines
	imgBackground.addImageObject('images/line.png', 25, 32);
	imgBackground.addImageObject('images/line.png', 25, 52);
	imgBackground.addImageObject('images/line.png', 25, 72);
	imgBackground.addImageObject('images/line.png', 25, 92);
	imgBackground.addImageObject('images/line.png', 25, 112);
	imgBackground.addImageObject('images/line.png', 25, 132);

	// contacts select effect images
	aSelectLines[0] = imgBackground.addImageObject('images/selected.png', 25, 14);
	aSelectLines[1] = imgBackground.addImageObject('images/selected.png', 25, 34);
	aSelectLines[2] = imgBackground.addImageObject('images/selected.png', 25, 54);
	aSelectLines[3] = imgBackground.addImageObject('images/selected.png', 25, 74);
	aSelectLines[4] = imgBackground.addImageObject('images/selected.png', 25, 94);
	aSelectLines[5] = imgBackground.addImageObject('images/selected.png', 25, 114);
	
	// contacts select effects images opacity
	aSelectLines[0].opacity = 0;
	aSelectLines[1].opacity = 0;
	aSelectLines[2].opacity = 0;
	aSelectLines[3].opacity = 0;
	aSelectLines[4].opacity = 0;
	aSelectLines[5].opacity = 0;

	// create ContactLine 1 controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 25;
	m.style.posTop = 15;
	m.style.posHeight = 15;
	m.style.posWidth = 80;
	m.onmouseover = selectContactLine1;
	m.onmouseout  = hideContactLine1;
	m.onclick = clickContactLine1;
	targets.appendChild(m);

	// create ContactLine 2 controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 25;
	m.style.posTop = 35;
	m.style.posHeight = 15;
	m.style.posWidth = 80;
	m.onmouseover = selectContactLine2;
	m.onmouseout  = hideContactLine2;
	m.onclick = clickContactLine2;
	targets.appendChild(m);

	// create ContactLine 3 controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 25;
	m.style.posTop = 55;
	m.style.posHeight = 15;
	m.style.posWidth = 80;
	m.onmouseover = selectContactLine3;
	m.onmouseout  = hideContactLine3;
	m.onclick = clickContactLine3;
	targets.appendChild(m);

	// create ContactLine 4 controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 25;
	m.style.posTop = 75;
	m.style.posHeight = 15;
	m.style.posWidth = 80;
	m.onmouseover = selectContactLine4;
	m.onmouseout  = hideContactLine4;
	m.onclick = clickContactLine4;
	targets.appendChild(m);

	// create ContactLine 5 controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 25;
	m.style.posTop = 95;
	m.style.posHeight = 15;
	m.style.posWidth = 80;
	m.onmouseover = selectContactLine5;
	m.onmouseout  = hideContactLine5;
	m.onclick = clickContactLine5;
	targets.appendChild(m);

	// create ContactLine 6 controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 25;
	m.style.posTop = 115;
	m.style.posHeight = 15;
	m.style.posWidth = 80;
	m.onmouseover = selectContactLine6;
	m.onmouseout  = hideContactLine6;
	m.onclick = clickContactLine6;
	targets.appendChild(m);

}

// Line select effect
function selectContactLine1() 
{ 
	if (!System.Gadget.Flyout.show) 
	{
		aSelectLines[0].opacity = 30; 
		strScroll = aContactsDisplayList[0+((iPageControl-1)*iMaxPageItems)][0];
		timerScroll = setTimeout("scrollContactName('strLine1',88,true)", timerDelay);
	}
}
function selectContactLine2() 
{ 
	if (!System.Gadget.Flyout.show) 
	{
		aSelectLines[1].opacity = 30; 
		strScroll = aContactsDisplayList[1+((iPageControl-1)*iMaxPageItems)][0];
		timerScroll = setTimeout("scrollContactName('strLine2',88,true)", timerDelay);
	}
}
function selectContactLine3() 
{ 
	if (!System.Gadget.Flyout.show) 
	{
		aSelectLines[2].opacity = 30;
		strScroll = aContactsDisplayList[2+((iPageControl-1)*iMaxPageItems)][0];
		timerScroll = setTimeout("scrollContactName('strLine3',88,true)", timerDelay); 
	}
}
function selectContactLine4() 
{ 
	if (!System.Gadget.Flyout.show) 
	{
		aSelectLines[3].opacity = 30; 
		strScroll = aContactsDisplayList[3+((iPageControl-1)*iMaxPageItems)][0];
		timerScroll = setTimeout("scrollContactName('strLine4',88,true)", timerDelay);
	}
}
function selectContactLine5() 
{ 
	if (!System.Gadget.Flyout.show) 
	{
		aSelectLines[4].opacity = 30; 
		strScroll = aContactsDisplayList[4+((iPageControl-1)*iMaxPageItems)][0];
		timerScroll = setTimeout("scrollContactName('strLine5',88,true)", timerDelay);
	}
}
function selectContactLine6() 
{ 
	if (!System.Gadget.Flyout.show) 
	{
		aSelectLines[5].opacity = 30; 
		strScroll = aContactsDisplayList[5+((iPageControl-1)*iMaxPageItems)][0];
		timerScroll = setTimeout("scrollContactName('strLine6',88,true)", timerDelay);
	}
}

// Line hide effect
function hideContactLine1() 
{ 
	aSelectLines[0].opacity = 0;
	strLine1.innerText = textFit('strLine1',aContactsDisplayList[0+((iPageControl-1)*iMaxPageItems)][0],88); 
	clearTimeout(timerScroll);
}
function hideContactLine2() 
{ 
	aSelectLines[1].opacity = 0; 
	strLine2.innerText = textFit('strLine2',aContactsDisplayList[1+((iPageControl-1)*iMaxPageItems)][0],88); 
	clearTimeout(timerScroll);
}
function hideContactLine3() 
{ 
	aSelectLines[2].opacity = 0;
	strLine3.innerText = textFit('strLine3',aContactsDisplayList[2+((iPageControl-1)*iMaxPageItems)][0],88); 
	clearTimeout(timerScroll); 
}
function hideContactLine4() 
{ 
	aSelectLines[3].opacity = 0; 
	strLine4.innerText = textFit('strLine4',aContactsDisplayList[3+((iPageControl-1)*iMaxPageItems)][0],88); 
	clearTimeout(timerScroll);
}
function hideContactLine5() 
{ 
	aSelectLines[4].opacity = 0; 
	strLine5.innerText = textFit('strLine5',aContactsDisplayList[4+((iPageControl-1)*iMaxPageItems)][0],88); 
	clearTimeout(timerScroll);
}
function hideContactLine6() 
{ 
	aSelectLines[5].opacity = 0; 
	strLine6.innerText = textFit('strLine6',aContactsDisplayList[5+((iPageControl-1)*iMaxPageItems)][0],88); 
	clearTimeout(timerScroll);
}


// Line click functions
function clickContactLine1() { if (!System.Gadget.Flyout.show) { iLineIndex = 0; clickContactLine(); } }
function clickContactLine2() { if (!System.Gadget.Flyout.show) { iLineIndex = 1; clickContactLine(); } }
function clickContactLine3() { if (!System.Gadget.Flyout.show) { iLineIndex = 2; clickContactLine(); } }
function clickContactLine4() { if (!System.Gadget.Flyout.show) { iLineIndex = 3; clickContactLine(); } }
function clickContactLine5() { if (!System.Gadget.Flyout.show) { iLineIndex = 4; clickContactLine(); } }
function clickContactLine6() { if (!System.Gadget.Flyout.show) { iLineIndex = 5; clickContactLine(); } }


// display contacts info on flyout page
function clickContactLine()
{

	if (!System.Gadget.Flyout.show)
	{

		var str = eval("strLine"+(iLineIndex+1)+".innerText;");

		// verify line length
		if (str.length > 0)
		{
			// put contact values into page variables to send the contacts info to Flyout page
			strContactName.value     = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][0];
			strContactPhone_1.value    = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][1];
			strContactPhone_2.value    = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][2];
			strContactPhone_3.value    = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][3];
			strContactPhone_4.value    = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][4];
			strContactMobile_1.value   = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][5];
			strContactMobile_2.value   = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][6];
			strContactMobile_3.value   = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][7];
			strContactMobile_4.value   = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][8];
			strContactWork_1.value     = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][9];
			strContactWork_2.value     = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][10];
			strContactEmail_1.value    = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][11];
			strContactEmail_2.value    = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][12];
			strContactSkype_1.value    = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][13];
			strContactIcq_1.value  	   = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][14];
			strContactComments_1.value = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][15];

			// initialize flyout return action
			//flyoutAction.value = "contactSelected";
			System.Gadget.Settings.write("flyoutAction", "contactSelected");

			// show the flyout page
			System.Gadget.Flyout.show = true;
		}
	}
}

// show phonebook tabs to change contacts by alphabet
function showTabs()
{

	// create tab buttons
	oTabs[0] = imgBackground.addImageObject('images/bTabBlue.png'  , 3, 5);	
	oTabs[1] = imgBackground.addImageObject('images/bTabRed.png'   , 3, 30);
	oTabs[2] = imgBackground.addImageObject('images/bTabYellow.png', 3, 55);
	oTabs[3] = imgBackground.addImageObject('images/bTabPurple.png', 3, 80);
	oTabs[4] = imgBackground.addImageObject('images/bTabGreen.png' , 3, 105);
	oTabs[5] = imgBackground.addImageObject('images/bTabOrange.png', 3, 130);

	// create tabBlue controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 3;
	m.style.posTop = 5;
	m.style.posHeight = 25;
	m.style.posWidth = 19;
	m.onmouseover = showTabBlue;
	m.onmouseout = hideTabBlue;
	m.onclick = clickTabBlue;
	targets.appendChild(m);

	// create tabRed controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 3;
	m.style.posTop = 30;
	m.style.posHeight = 25;
	m.style.posWidth = 19;
	m.onmouseover = showTabRed;
	m.onmouseout = hideTabRed;
	m.onclick = clickTabRed;
	targets.appendChild(m);

	// create tabYellow controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 3;
	m.style.posTop = 55;
	m.style.posHeight = 25;
	m.style.posWidth = 19;
	m.onmouseover = showTabYellow;
	m.onmouseout = hideTabYellow;
	m.onclick = clickTabYellow;
	targets.appendChild(m);

	// create tabPurple controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 3;
	m.style.posTop = 80;
	m.style.posHeight = 25;
	m.style.posWidth = 19;
	m.onmouseover = showTabPurple;
	m.onmouseout = hideTabPurple;
	m.onclick = clickTabPurple;
	targets.appendChild(m);

	// create tabGreen controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 3;
	m.style.posTop = 105;
	m.style.posHeight = 25;
	m.style.posWidth = 19;
	m.onmouseover = showTabGreen;
	m.onmouseout = hideTabGreen;
	m.onclick = clickTabGreen;
	targets.appendChild(m);

	// create tabOrange controls
	var m = document.createElement('DIV');
	m.className = 'target';
	m.style.posLeft = 3;
	m.style.posTop = 130;
	m.style.posHeight = 25;
	m.style.posWidth = 19;
	m.onmouseover = showTabOrange;
	m.onmouseout = hideTabOrange;
	m.onclick = clickTabOrange;
	targets.appendChild(m);

	// change tabs opacity
	oTabs[0].opacity = 60;
	oTabs[1].opacity = 60;
	oTabs[2].opacity = 60;
	oTabs[3].opacity = 60;
	oTabs[4].opacity = 60;
	oTabs[5].opacity = 60;

}

// Tab select effect
function showTabBlue()   { if (!System.Gadget.Flyout.show && (strTab1.innerText != "" || strUp.innerText != "") ) oTabs[0].opacity = 100; }
function showTabRed()    { if (!System.Gadget.Flyout.show && strTab2.innerText != "") oTabs[1].opacity = 100; }
function showTabYellow() { if (!System.Gadget.Flyout.show && strTab3.innerText != "") oTabs[2].opacity = 100; }
function showTabPurple() { if (!System.Gadget.Flyout.show && strTab4.innerText != "") oTabs[3].opacity = 100; }
function showTabGreen()  { if (!System.Gadget.Flyout.show && strTab5.innerText != "") oTabs[4].opacity = 100; }
function showTabOrange() { if (!System.Gadget.Flyout.show && (strTab6.innerText != "" || strDown.innerText != "")) oTabs[5].opacity = 100; }

// Tab select effect
function hideTabBlue()   { if (iTabIndex != 0) oTabs[0].opacity = 60; } 
function hideTabRed()    { if (iTabIndex != 1) oTabs[1].opacity = 60; }
function hideTabYellow() { if (iTabIndex != 2) oTabs[2].opacity = 60; }
function hideTabPurple() { if (iTabIndex != 3) oTabs[3].opacity = 60; }
function hideTabGreen()  { if (iTabIndex != 4) oTabs[4].opacity = 60; }
function hideTabOrange() { if (iTabIndex != 5) oTabs[5].opacity = 60; }

// Tab click action
function clickTabBlue()   { if (!System.Gadget.Flyout.show && (strTab1.innerText != "" || strUp.innerText != "")) { oTabs[iTabIndex].opacity = 60; iTabIndex = 0; showTabsText(true); } }
function clickTabRed()    { if (!System.Gadget.Flyout.show && strTab2.innerText != "") { oTabs[iTabIndex].opacity = 60; iTabIndex = 1; showTabsText(true); } }
function clickTabYellow() { if (!System.Gadget.Flyout.show && strTab3.innerText != "") { oTabs[iTabIndex].opacity = 60; iTabIndex = 2; showTabsText(true); } }
function clickTabPurple() { if (!System.Gadget.Flyout.show && strTab4.innerText != "") { oTabs[iTabIndex].opacity = 60; iTabIndex = 3; showTabsText(true); } }
function clickTabGreen()  { if (!System.Gadget.Flyout.show && strTab5.innerText != "") { oTabs[iTabIndex].opacity = 60; iTabIndex = 4; showTabsText(true); } }
function clickTabOrange() { if (!System.Gadget.Flyout.show && (strTab6.innerText != "" || strDown.innerText != "")) { oTabs[iTabIndex].opacity = 60; iTabIndex = 5; showTabsText(true); } }

// show the phonebook Tabs text 
function showTabsText( bInitPage)
{

	try
	{
		// update alphabet index control
		if (iTabIndex == 5 && aAlphabet[iAlphaIndex + 5] == 'q' && iAlphaIndex < 36) {
			iAlphaIndex = iAlphaIndex + 6;
			iTabIndex = 1;
		}

		if (iTabIndex == 0 && aAlphabet[iAlphaIndex] == 'p' && iAlphaIndex > 0) {
			iAlphaIndex = iAlphaIndex - 6;
			if (iAlphaIndex <= 0)
				iTabIndex = 0;
			else
				iTabIndex = 1;
		}

		// display TAB1 text
		if (aAlphabet[iAlphaIndex] == 'p')
		{
			strTab1.innerText = '';
			strUp.innerText = aAlphabet[iAlphaIndex];
		}
		else
		{
			strTab1.innerText = aAlphabet[iAlphaIndex];
			strUp.innerText = '';
		}

		// display TAB2 text
		strTab2.innerText = aAlphabet[iAlphaIndex + 1];
		// display TAB3 text
		strTab3.innerText = aAlphabet[iAlphaIndex + 2];
		// display TAB4 text
		strTab4.innerText = aAlphabet[iAlphaIndex + 3];
		// display TAB5 text
		strTab5.innerText = aAlphabet[iAlphaIndex + 4];

		// TAB 6
		if (aAlphabet[iAlphaIndex + 5] == 'q')
		{
			strTab6.innerText = '';
			strDown.innerText = aAlphabet[iAlphaIndex + 5];
		}
		else
		{
			strTab6.innerText = aAlphabet[iAlphaIndex + 5];
			strDown.innerText = '';
		}

	
		// reduce tabs opacity
		oTabs[0].opacity = 60;
		oTabs[1].opacity = 60;
		oTabs[2].opacity = 60;
		oTabs[3].opacity = 60;
		oTabs[4].opacity = 60;
		oTabs[5].opacity = 60;

		// highlight selected Tab
		oTabs[iTabIndex].opacity = 100;

		// initialize page control
		if (bInitPage)
			iPageControl = 1;

		// load and display contact list based on selected tab
		eval("loadContactDisplayList('"+aAlphabet[iAlphaIndex + iTabIndex]+"');");
		eval("showContacts('"+aAlphabet[iAlphaIndex + iTabIndex]+"');");
	}
	catch(err)
	{
  		strErrMsg = 'showTabsText:';
		strErrMsg += '\n:' + err.number;
  		strErrMsg += '\n:' + err.description;
		iCountdown = 10;
		iSeconds = 0;
		showError();
	}

}

// adjust the text to fit on phonebook page
function textFit( strName, strObject, strMaxWidthPx)
{

	var bLong = false;

	for( var i = 1; i <= strObject.length; i++)
	{
		if (bLong)
			eval(strName+".innerText = strObject.substr(0,i).concat('...');");
		else
			eval(strName+".innerText = strObject.substr(0,i);");
		
		if ( eval("("+strName+".offsetWidth > strMaxWidthPx)") )
		{
			if (bLong)
				return strObject.substr(0,i-1).concat("...");
			else
			{
				bLong = true;
				i = i-5;
			}
			
		}
	}

	return strObject;
	
}

// load contacts from mains contacts array and put them into display list array
function loadContactDisplayList( strAlpha)
{

	try
	{
		var i;
		var itemsCount = 0;
	
		// remove all contacts from contacts display list
		aContactsDisplayList.splice(0,aContactsDisplayList.length);

		// load all contacts beginning with "strAlpha" into displaylist array
		for (i = 0; i < aContacts.length; i++)
		{
		
			if (strAlpha == '#') // Contacts begins with numbers and symbols (65 = A / 90 = Z)
			{
				if (aContacts[i][0].toUpperCase().charCodeAt(0) < 65 
					|| aContacts[i][0].toUpperCase().charCodeAt(0) > 90)
				{
					// add contact array info
					aContactsDisplayList.push(aContacts[i]);
					aContactsDisplayList[itemsCount][16] = i;
					itemsCount++;
				}
			}
			else
			{
				if (aContacts[i][0].charAt(0).toUpperCase() == strAlpha)
				{
					// add contact array info
					aContactsDisplayList.push(aContacts[i]);
					aContactsDisplayList[itemsCount][16] = i;
					itemsCount++;
				}
			}
		}

		// define page control values
		iMaxPages = Math.ceil((itemsCount/iMaxPageItems));
		if (iMaxPages == 0) iMaxPages = 1;
	}
	catch(err)
	{
  		strErrMsg = 'loadContactDisplayList';
		strErrMsg += '\n:' + err.number;
  		strErrMsg += '\n:' + err.description;
		iCountdown = 10;
		iSeconds = 0;
		showError();
	}

}

// show contacts from display list array
function showContacts()
{

	try
	{
		var i = 0;
		var first = -1;
		var length;
		var initial;

		// calculate remaining items on array
		if ( (aContactsDisplayList.length - ( (iPageControl-1) * iMaxPageItems ) ) > 6)
			length = 6;
		else
			length = aContactsDisplayList.length - ((iPageControl-1)*iMaxPageItems);

		// calculate initial array value based on page control
		initial = (iPageControl-1) * iMaxPageItems;

		// clean-up all textlines
		strLine1.innerText = "";
		strLine2.innerText = "";
		strLine3.innerText = "";
		strLine4.innerText = "";
		strLine5.innerText = "";
		strLine6.innerText = "";

		// display contacts based on selected page
		for (i = 0; i < length; i++)
		{
			eval("strLine"
				+(i+1)
				+".innerText = textFit('strLine"
				+(i+1)
				+"', aContactsDisplayList["
				+(i+initial)
				+"][0], 88);");
		}

		// update page control	info
		strPage.innerText = iPageControl + " / " + iMaxPages;
	}
	catch(err)
	{
  		strErrMsg = 'showContacts:';
		strErrMsg += '\n:' + err.number;
  		strErrMsg += '\n:' + err.description;
		iCountdown = 10;
		iSeconds = 0;
		showError();
	}

}

// show Flyout actions
function showFlyout() 
{	
	
	// contacts select effects images opacity
	aSelectLines[0].opacity = 0;
	aSelectLines[1].opacity = 0;
	aSelectLines[2].opacity = 0;
	aSelectLines[3].opacity = 0;
	aSelectLines[4].opacity = 0;
	aSelectLines[5].opacity = 0;

	// controls buttons select effect 
	aControls[0].opacity = 100;
	aControls[1].opacity = 0;
	aControls[2].opacity = 100;
	aControls[3].opacity = 0;
	aControls[4].opacity = 100;
	aControls[5].opacity = 0;

	// disable scroll effect
	if (strLine1.innerText != "") strLine1.innerText = textFit('strLine1',aContactsDisplayList[0+((iPageControl-1)*iMaxPageItems)][0],88); 
	if (strLine2.innerText != "") strLine2.innerText = textFit('strLine2',aContactsDisplayList[1+((iPageControl-1)*iMaxPageItems)][0],88); 
	if (strLine3.innerText != "") strLine3.innerText = textFit('strLine3',aContactsDisplayList[2+((iPageControl-1)*iMaxPageItems)][0],88); 
	if (strLine4.innerText != "") strLine4.innerText = textFit('strLine4',aContactsDisplayList[3+((iPageControl-1)*iMaxPageItems)][0],88); 
	if (strLine5.innerText != "") strLine5.innerText = textFit('strLine5',aContactsDisplayList[4+((iPageControl-1)*iMaxPageItems)][0],88); 
	if (strLine6.innerText != "") strLine6.innerText = textFit('strLine6',aContactsDisplayList[5+((iPageControl-1)*iMaxPageItems)][0],88); 
	clearTimeout(timerScroll);

	// put focus on flyout page
	self.focus(); 
	
	// put focus on Name textbox
	System.Gadget.Flyout.document.getElementById("strName").focus();
}

// hide Flyout actions
function hideFlyout() 
{	

	try
	{
		var position
		var prevId = 0;
		var strAlpha = "";
		var strCode;
		var strCompA;
		var strCompB;

		switch (System.Gadget.Settings.read("flyoutAction")) //flyoutAction.value)
		{

		// update contact info information
		case "update":
	
			position = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][16];

			// get contact info changes
			aContacts[position][0]  = strContactName.value;
			aContacts[position][1]  = strContactPhone_1.value;
			aContacts[position][2]  = strContactPhone_2.value;
			aContacts[position][3]  = strContactPhone_3.value;
			aContacts[position][4]  = strContactPhone_4.value;
			aContacts[position][5]  = strContactMobile_1.value;
			aContacts[position][6]  = strContactMobile_2.value;
			aContacts[position][7]  = strContactMobile_3.value;
			aContacts[position][8]  = strContactMobile_4.value;
			aContacts[position][9]  = strContactWork_1.value;
			aContacts[position][10] = strContactWork_2.value;
			aContacts[position][11] = strContactEmail_1.value;
			aContacts[position][12] = strContactEmail_2.value;
			aContacts[position][13] = strContactSkype_1.value;
			aContacts[position][14] = strContactIcq_1.value;
			aContacts[position][15] = strContactComments_1.value;

			locateUpdatedContact( strContactName.value, aContacts[position][17]);
			showTabsText(false);

			// update XML file
			writeContactsXML();
			
			break;

		// update contact info information
		case "add":

			// add contact 
			aContacts.push([strContactName.value
					,strContactPhone_1.value
					,strContactPhone_2.value
					,strContactPhone_3.value
					,strContactPhone_4.value
					,strContactMobile_1.value
					,strContactMobile_2.value
					,strContactMobile_3.value
					,strContactMobile_4.value
					,strContactWork_1.value
					,strContactWork_2.value
					,strContactEmail_1.value
					,strContactEmail_2.value
					,strContactSkype_1.value
					,strContactIcq_1.value
					,strContactComments_1.value 
					,0
					,iContactId++]);

			locateUpdatedContact( strContactName.value, (iContactId-1));
			showTabsText(false);

			// update XML file
			writeContactsXML();

			break;


		// update contact info information
		case "remove":

			position = aContactsDisplayList[iLineIndex+((iPageControl-1)*iMaxPageItems)][16];
	
			strAlpha = aContacts[position][0];
			prevId = -1;

			if (position < (aContacts.length-1))
			{

				strCode = aContacts[(position)][0].toUpperCase().charCodeAt(0);
				if (strCode < 65 || strCode > 90)
					strCompA = "#";
				else
					strCompA = aContacts[(position)][0].toUpperCase().charAt(0);
		
				strCode = aContacts[(position+1)][0].toUpperCase().charCodeAt(0);
				if (strCode < 65 || strCode > 90)
					strCompB = "#";
				else
					strCompB = aContacts[(position+1)][0].toUpperCase().charAt(0);
	
				if ( strCompA == strCompB )
					prevId = aContacts[position+1][17];

			}
		
			if (prevId < 0 && position > 0)
			{

				strCode = aContacts[(position)][0].toUpperCase().charCodeAt(0);
				if (strCode < 65 || strCode > 90)
					strCompA = "#";
				else
					strCompA = aContacts[(position)][0].toUpperCase().charAt(0);
		
				strCode = aContacts[(position-1)][0].toUpperCase().charCodeAt(0);
				if (strCode < 65 || strCode > 90)
					strCompB = "#";
				else
					strCompB = aContacts[(position-1)][0].toUpperCase().charAt(0);

				if ( strCompA == strCompB )
					prevId = aContacts[position-1][17];


			}	


			// remove contact from array
			aContacts.splice(position,1);

			locateUpdatedContact( strAlpha, prevId);
			showTabsText(false);

			// update XML file
			writeContactsXML();

			break;

		}

		// initialize flyout return action
		//flyoutAction.value = "";
		System.Gadget.Settings.write("flyoutAction", "");

	}
	catch(err)
	{
  		strErrMsg = 'showContacts:';
		strErrMsg += '\n:' + err.number;
  		strErrMsg += '\n:' + err.description;
		iCountdown = 10;
		iSeconds = 0;
		showError();
	}
	
}


function showError()
{

	var strSeconds;

	document.getElementById("divError").style.visibility = "visible";

	if (iCountdown > 0 && iRestartAttempts < 3)
	{
		strSeconds = '\n\n  ' + (iCountdown-iSeconds) + ' ...';
		strError.innerText = textLineFeed("strError", strErrMsg + strSeconds, 100);
		iSeconds++;

		if (iSeconds <= iCountdown)
			timerError = setTimeout("showError()", 1000);
		else
		{
			clearTimeout(timerError);
			document.getElementById("divError").style.visibility = "hidden";
			System.Gadget.Settings.write("settingsAction", "reload");
			reloadPhonebook();
		}
	}
	else
		strError.innerText = textLineFeed("strError", strErrMsg, 100);


}

// Main Function
function initPhonebook()
{

	// Gadget settings page
	System.Gadget.settingsUI = "Settings.html";
	System.Gadget.onSettingsClosed = reloadPhonebook;

	// Specify the flyout root.
	System.Gadget.Flyout.file = "ContactInfo.html";
	System.Gadget.Flyout.onShow = showFlyout;
	System.Gadget.Flyout.onHide = hideFlyout;

	// init variables
	iAlphaIndex = 0;
	iTabIndex = 0;
	iLineIndex = 0;
	iPageControl = 1;
	iMaxPages = 1;
	iRestartAttempts = 0;

	// init display objects
	loadAlphabet();
	loadContacts();
	showControls();
	showTextLines();
	showTabs();
	showTabsText(true);

}

function reloadPhonebook()
{
	if (System.Gadget.Settings.read("settingsAction") == "reload")
	{
		aContacts.splice(0, aContacts.length);
		loadContacts();
		iAlphaIndex = 0;
		iTabIndex = 0;
		iLineIndex = 0;
		iPageControl = 1;
		iMaxPages = 1;
		showTabsText(true);
	}
	
}

function scrollContactName( strVar, strMaxWidthPx, bInit)
{

	if (bInit)
	{
		strTextFit.innerText = strScroll;
		if ( strTextFit.offsetWidth > strMaxWidthPx )
			strScroll = strScroll.concat("    ");
	}
	
	// verify line length
	if ( !System.Gadget.Flyout.show )
	{
		strScroll = strScroll.substring(1,strScroll.length) + strScroll.substring(0,1);
		for( var i = 1; i <= strScroll.length; i++)
		{
			strTextFit.innerText = strScroll.substr(0,i);
			if ( strTextFit.offsetWidth > strMaxWidthPx )
			{
				eval(strVar
					+".innerText = '"
					+strScroll.substr(0,i-1)
					+"';");
				break;
			}
		}
		timerScroll = setTimeout("scrollContactName('"+strVar+"',88, false)", timerDelay);
	}

}
